VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "courses"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' this class contains a collection of course objects
' and the methods that go with that
Private m_courses As Collection

' We declare an event called DataError that takes a string
' this will be raised at the appropriate time to signal
' to the main form that an error has ocurred. The string
' will contain details on the error.
' In any project that uses this class, the DataError event will
' show up in the Events pull down and so
' the main form code can contain a handler function like
'Private Sub clslist_DataError(ByVal mesg As String)
' In addition, when we declare a variable of this
' class we have to add the WithEvents modifier like this
' from the form code
' Dim WithEvents clslist As courses
Public Event DataError(ByVal mesg As String) '

' The class initialization code is run when an instance
' of the class is created with the new command
Private Sub Class_Initialize()
    Set m_courses = New Collection
End Sub

' When the instance of the class is deleted or
' not being used anymore, this code is run.
' it is used to cleanup things
' The way that objects are deleted is to set the
' variable holding them to Nothing
Private Sub Class_Terminate()
MsgBox "object terminated"
    Set m_courses = Nothing
End Sub

' We have an add() method which just calls the
' add method of the collection object
Public Sub add(ByRef cls As course)
    m_courses.add cls
End Sub

' Our wrapper around the collection item function
Public Function item(ByVal index As Integer) As course
    Set item = m_courses.item(index)
End Function

Public Property Get count() As Variant
    count = m_courses.count
End Property

' This is a trick to get our class to look
' like an ordinary collection so we can
' use the for each statement on it
Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = m_courses.[_NewEnum]
End Function

' This will read from the INI file and store the
' information in the collection.
' There are a number of Class sections in the file,
' each one has a number appended to it.
' We use the sGetIni function to read the
' Name field from each one.
' If there is no Name field (we will know this
' when the sGetIni call returns the default value, the
' fourth argument) we stop. If the count
' of records is 0, then we raise the DataError event.
' This is a kind of exception processing technique.
' If there is data for the class, we use more calls
' to sGetIni to get the rest of the class data
Public Sub loadfromini(ifile As String)
    Dim scount As Integer, schnum As Integer
    Dim section As String, temp As String
    Dim cls As course
    scount = 0
    
    Do While True
        section = "Class" & CStr(scount) ' next section name
        temp = sGetINI(ifile, section, "Name", "?")
        If temp <> "?" Then ' read rest of data
            Set cls = New course ' create a new course object
            cls.ClassName = temp
            
            cls.Dept = sGetINI(ifile, section, "Dept", "?")
            cls.classnum = sGetINI(ifile, section, "Classnum", "?")
            cls.school = sGetINI(ifile, section, "School", "?")
            m_courses.add cls ' store new object in collection
            scount = scount + 1
        Else
            Exit Do ' no more class data in file
        End If
    Loop
    If scount = 0 Then RaiseEvent DataError("no class count in file " & ifile)
End Sub
