VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "stringset"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' This acts like a collection, but with the aditional property
' that if you add a value that is already here, it doesn't
' add it to the collection.
' This is intended to hold strings

Private coll As Collection  ' this is the actual collection
Private current As Integer

' this is called when the class is instantiated, like
' when new is called
Public Sub Class_Initialize()
    Set coll = New Collection
    current = 1
End Sub

' called when the class is destroyed
Public Sub Class_Terminate()
    Set coll = Nothing ' frees the memory used by the collection
End Sub

' make the course object look like a collection
' by pass the actual collection count
Public Property Get count() As Integer
    count = coll.count
End Property

' This does the actual work
' when the user tries to add a new object to the collection,
' we first look through the collection to see if it
' already there and only adds it if it isn't there
Public Sub add(newval As String)
    Dim thing As Variant ' needed for the for each
    If newval = "" Then ' don't bother with empty strings
        Exit Sub
    End If
    
    For Each thing In coll
        If thing = newval Then 'it's already there
            Exit Sub
        End If
    Next thing
    coll.add newval ' it's not there, add it
End Sub

' check the index for legal range
' and then just return the value stored there
Public Function item(index As Integer) As String
    If index > 0 And index < coll.count Then
        item = coll.item(index)
    End If
End Function

' getnext is called an iterator
' each time it is called, it returns the next thing
' in this case, each time it returns the
' next string stored in the collection
' To do this, we are using a global private variable
' stored in the class.
' This works because for each stringset that is created, there is
' one current variable and it acts like a global
' variable for the methods in the class
Public Function getnext() As String
    ' if the current is greater than the actual number of records
    ' in the collection,we reset the current counter and
    ' return an empty string so the calling code
    ' knows it has reached the end
    If current > coll.count Then
        current = 1
        getnext = ""
    Else
        getnext = coll.item(current)
        current = current + 1
    End If
End Function
